## pforth 2.0.1

=== CMakeLists.txt ===
# NAME/CMakeLists.txt
# Original file by Robin Rowe 2020-05-01
# Extended by Phil Burk 2021-10-31
# License: BSD Zero

# To build pforth:
#
#    cmake .
#    make
#
# That will create the following files:
#    fth/pforth   # executable that loads pforth.dic
#    fth/pforth.dic
#    fth/pforth_standalone # executable that does not need a .dic file
#
# The build has several steps
# 1. Build pforth executable
# 2. Build pforth.dic by compiling system.fth
# 3. Create a pfdicdat.h header containing a precompiled dictionary
#    as C source code.
# 4.  Build pforth_standalone using the precompiled dictionary.

cmake_minimum_required(VERSION 3.6)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Put pforth in the fth folder so we can load the Forth code more easily.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/fth)

project(PForth)
message("Configuring ${PROJECT_NAME}...")
enable_testing()

if(WIN32)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    message("Warning: _CRT_SECURE_NO_WARNINGS")
endif(WIN32)

add_subdirectory(csrc)
if(NOT WIN32 AND NOT APPLE)
	link_libraries(rt pthread)
endif(NOT WIN32 AND NOT APPLE)

option(UNISTD "Enable libunistd" false)
if(UNISTD)
	set(LIBUNISTD_PATH /code/github/libunistd)
	if(WIN32)
		include_directories(${LIBUNISTD_PATH}/unistd)
		link_directories(${LIBUNISTD_PATH}/build/unistd/Release)
		link_libraries(libunistd)
	endif(WIN32)
endif(UNISTD)

# 1. Build pforth executable
add_executable(pforth csrc/pf_main.c)
target_link_libraries(pforth ${PROJECT_NAME}_lib m)

# 2. Build pforth.dic by compiling system.fth
set(PFORTH_DIC "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/pforth.dic")
add_custom_command(OUTPUT ${PFORTH_DIC}
  COMMAND ./pforth -i system.fth
  WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
  DEPENDS pforth
  COMMENT Building pforth.dic
  VERBATIM
  )
add_custom_target(pforth_dic DEPENDS ${PFORTH_DIC})

# 3. Create a pfdicdat.h header containing a precompiled dictionary
#    as C source code.
set(PFORTH_DIC_HEADER "csrc/pfdicdat.h")
add_custom_command(OUTPUT ${PFORTH_DIC_HEADER}
  COMMAND ./pforth mkdicdat.fth
  COMMAND mv pfdicdat.h ../csrc/.
  WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
  DEPENDS pforth_dic
  COMMENT Building pfdicdat.h
  VERBATIM
  )
add_custom_target(pforth_dic_header DEPENDS ${PFORTH_DIC_HEADER})
add_dependencies(${PROJECT_NAME}_lib_sd pforth_dic_header)

# 4. Build pforth_standalone using the precompiled dictionary.
add_executable(pforth_standalone csrc/pf_main.c)
target_link_libraries(pforth_standalone ${PROJECT_NAME}_lib_sd m)
target_compile_definitions(pforth_standalone PRIVATE PF_STATIC_DIC)
add_dependencies(pforth_standalone pforth_dic_header)

=== csrc/CMakeLists.txt ===
# pforth/csrc/CMakeLists.txt
# Extended by Phil Burk 2021-10-31
# License: BSD Zero

file(STRINGS sources.cmake SOURCES)

if(WIN32)
set(PLATFORM stdio/pf_fileio_stdio.c win32_console/pf_io_win32_console.c )
endif(WIN32)

if(UNIX OR APPLE)
set(PLATFORM posix/pf_io_posix.c stdio/pf_fileio_stdio.c)
endif(UNIX OR APPLE)

if (MSVC)
    # warning level 4 and all warnings as errors
    add_compile_options(/W4 /WX)
else()
    # lots of warnings and all warnings as errors
    add_compile_options(
#        --std=c89
        -fsigned-char
        -fno-builtin
        -fno-unroll-loops
        -pedantic
        -Wcast-qual
        -Wall
        -Werror
        -Wwrite-strings
        -Winline
        -Wmissing-prototypes
        -Wmissing-declarations
        )
endif()

add_library(${PROJECT_NAME}_lib ${SOURCES} ${PLATFORM})
target_compile_definitions(${PROJECT_NAME}_lib PRIVATE PF_SUPPORT_FP)

# Compile the same library but with an option for the static dictionary.
add_library(${PROJECT_NAME}_lib_sd STATIC ${SOURCES} ${PLATFORM})
target_compile_definitions(${PROJECT_NAME}_lib_sd PRIVATE PF_STATIC_DIC)
target_compile_definitions(${PROJECT_NAME}_lib_sd PRIVATE PF_SUPPORT_FP)

=== platforms/linux-crossbuild-amiga/Makefile ===
# This Makefile can be used to cross-compile pForth on a Linux host to
# an Amiga target.  GCC is used as host-compiler and VBCC as
# cross-compiler.

# makefile for pForth
# Portable Forth written in 'C'
# by Phil Burk
# For more info visit http://www.softsynth.com/pforth/
#
# See "help" target below.

# Options include: PF_SUPPORT_FP PF_NO_MALLOC PF_NO_INIT PF_DEBUG
# See "docs/pf_ref.htm" file for more info.

# We are going to use VBCC as cross compiler.  I've installed VBCC
# under /opt/m68k-amigaos.  It's configured to generate Motorola 680x0 code in
# "Amiga Hunk" object format.
VBCC := /opt/m68k-amigaos
PATH := $(VBCC)/bin:$(PATH)
XCC          = vc # The VBCC compiler

SRCDIR       = ../..
PFORTHDIR    = $(SRCDIR)
CSRCDIR      = $(PFORTHDIR)/csrc
FTHDIR       = $(PFORTHDIR)/fth

PFDICAPP     = pforth
PFORTHDIC    = pforth.dic
PFDICDAT     = pfdicdat.h
PFORTHAPP    = amiga_pforth_standalone

# We need to create a 32-bit dictionary
WIDTHOPT= -m32
DEBUGOPTS = -g
FULL_WARNINGS =  \
        --std=c89 \
        -pedantic \
        -Wcast-qual \
        -Wall \
        -Wwrite-strings \
        -Winline  \
        -Wmissing-prototypes \
        -Wmissing-declarations
CCOPTS = $(WIDTHOPT) -x c -O2 $(FULL_WARNINGS) $(EXTRA_CCOPTS) $(DEBUGOPTS)

#IO_SOURCE = pf_io_posix.c
IO_SOURCE = pf_io_stdio.c pf_fileio_stdio.c
#IO_SOURCE = pf_io_win32_console.c

EMBCCOPTS = -DPF_STATIC_DIC

#######################################
PFINCLUDES = pf_all.h pf_cglue.h pf_clib.h pf_core.h pf_float.h \
	pf_guts.h pf_host.h pf_inc1.h pf_io.h pf_mem.h pf_save.h \
	pf_text.h pf_types.h pf_words.h pfcompfp.h \
	pfcompil.h pfdicdat_arm.h pfinnrfp.h pforth.h
PFBASESOURCE = pf_cglue.c pf_clib.c pf_core.c pf_inner.c \
	pf_io.c pf_io_none.c pf_main.c pf_mem.c pf_save.c \
	pf_text.c pf_words.c pfcompil.c pfcustom.c
PFSOURCE = $(PFBASESOURCE) $(IO_SOURCE)

VPATH = .:$(CSRCDIR):$(CSRCDIR)/posix:$(CSRCDIR)/stdio


CPPFLAGS = -I. -DPF_BIG_ENDIAN_DIC -DPF_SUPPORT_FP
CFLAGS = $(CCOPTS)
LDFLAGS = $(WIDTHOPT) -lm

COMPILE = $(CC) $(CFLAGS) $(CPPFLAGS)

# Cross compiler flags (for VBCC not gcc)
XCFLAGS = -c99 -O3
#XCPPFLAGS = -DPF_SUPPORT_FP -DWIN32
XCPPFLAGS = -I. -DAMIGA -DPF_SUPPORT_FP
XLDFLAGS = -lmieee -lm881

XCOMPILE = $(XCC) $(XCFLAGS) $(XCPPFLAGS)
XLINK = $(XCC) $(XLDFLAGS)

.SUFFIXES: .c .o .eo

PFOBJS     = $(PFSOURCE:.c=.o)
PFEMBOBJS  = $(PFSOURCE:.c=.eo)

.c.o: $(PFINCLUDES)
	$(COMPILE) -c -o $@ $<

.c.eo: $(PFINCLUDES) pfdicdat.h
	$(XCOMPILE) $(EMBCCOPTS) -c -o $@ $<

.PHONY: all clean test
.PHONY: help pffiles pfdicapp pfdicdat pforthapp

all: $(PFORTHAPP)

pffiles:
	@echo "INCLUDE FILES -----------------"
	@echo ${PFINCLUDES}
	@echo "'C' FILES ---------------------"
	@echo ${PFSOURCE}
	@echo "OBJECT FILES ------------------"
	@echo ${PFOBJS}
	@echo "EMBEDDED OBJECT FILES ------------------"
	@echo ${PFEMBOBJS}

# Build pforth by compiling 'C' source.
$(PFDICAPP): $(PFINCLUDES) $(PFOBJS)
	$(CC) -o $@ $(PFOBJS) $(LDADD) $(LDFLAGS)

# Build basic dictionary image by running newly built pforth and including "system.fth".
$(PFORTHDIC): $(PFDICAPP)
	wd=$$(pwd); (cd $(FTHDIR); $${wd}/$(PFDICAPP) -i system.fth)
	(cd $(FTHDIR); cat pforth.dic; rm -f pforth.dic) > $@

$(PFDICDAT): $(PFORTHDIC) $(PFDICAPP)
	echo 'include $(FTHDIR)/savedicd.fth SDAD'>load-dict-tmp.fth&& ./$(PFDICAPP) -d $(PFORTHDIC) load-dict-tmp.fth; rm -f load-dict-tmp.fth

$(PFORTHAPP): $(PFDICDAT) $(PFEMBOBJS)
	$(XLINK) -o $@ $(PFEMBOBJS) $(XLDADD)
	@echo ""
	@echo "Standalone pForth executable written to $(PFORTHAPP)"


# target aliases
pfdicapp: $(PFDICAPP)

pfdicdat: $(PFDICDAT)

pforthapp: $(PFORTHAPP)

help:
	@echo "Use 'make all' to build standalone pForth executable."
	@echo "PForth can be built in several stages using these targets:"
	@echo "   pfdicapp = executable pForth with minimal dictionary. All from 'C'."
	@echo "   pfdicdat = image of full dictionary build by compiling Forth code."
	@echo "   pforthapp = executable with embedded dictionary image. DEFAULT 'all' target."
	@echo ""
	@echo "   The file 'fth/pfdicdat.h' is generated by pForth. It contains a binary image of the Forth dictionary."
	@echo "   It allows pForth to work as a standalone image that does not need to load a dictionary file."

test: $(PFORTHAPP)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_corex.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_strings.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_locals.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_alloc.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_floats.fth)

clean:
	rm -f $(PFOBJS) $(PFEMBOBJS)
	rm -f $(PFORTHAPP)
	rm -f $(PFDICDAT) $(FTHDIR)/$(PFDICDAT)
	rm -f $(PFORTHDIC) $(FTHDIR)/$(PFORTHDIC)
	rm -f $(PFDICAPP)

=== platforms/linux-crossbuild-atari/Makefile ===
# This Makefile can be used to cross-compile pForth on a Linux host to
# an Atari ST target.  GCC is used as host-compiler and VBCC as
# cross-compiler.

# makefile for pForth
# Portable Forth written in 'C'
# by Phil Burk
# For more info visit http://www.softsynth.com/pforth/
#
# See "help" target below.

# Options include: PF_SUPPORT_FP PF_NO_MALLOC PF_NO_INIT PF_DEBUG
# See "docs/pf_ref.htm" file for more info.

# We are going to use VBCC as cross compiler.  I've installed VBCC
# under /opt/vbcc.  It's configured to generate Motorola 680x0 code.
VBCC := /opt/vbcc
PATH := $(VBCC)/bin:$(PATH)
XCC          = vc # The VBCC compiler

SRCDIR       = ../..
PFORTHDIR    = $(SRCDIR)
CSRCDIR      = $(PFORTHDIR)/csrc
FTHDIR       = $(PFORTHDIR)/fth

PFDICAPP     = pforth
PFORTHDIC    = pforth.dic
PFDICDAT     = pfdicdat.h
PFORTHAPP    = pforth.ttp

# We need to create a 32-bit dictionary
WIDTHOPT= -m32
DEBUGOPTS = -g
FULL_WARNINGS =  \
        --std=c89 \
        -pedantic \
        -Wcast-qual \
        -Wall \
        -Wwrite-strings \
        -Winline  \
        -Wmissing-prototypes \
        -Wmissing-declarations
CCOPTS = $(WIDTHOPT) -x c -O2 $(FULL_WARNINGS) $(EXTRA_CCOPTS) $(DEBUGOPTS)

#IO_SOURCE = pf_io_posix.c
IO_SOURCE = pf_io_stdio.c pf_fileio_stdio.c
#IO_SOURCE = pf_io_win32_console.c

EMBCCOPTS = -DPF_STATIC_DIC

#######################################
PFINCLUDES = pf_all.h pf_cglue.h pf_clib.h pf_core.h pf_float.h \
	pf_guts.h pf_host.h pf_inc1.h pf_io.h pf_mem.h pf_save.h \
	pf_text.h pf_types.h pf_words.h pfcompfp.h \
	pfcompil.h pfdicdat_arm.h pfinnrfp.h pforth.h
PFBASESOURCE = pf_cglue.c pf_clib.c pf_core.c pf_inner.c \
	pf_io.c pf_io_none.c pf_main.c pf_mem.c pf_save.c \
	pf_text.c pf_words.c pfcompil.c pfcustom.c
PFSOURCE = $(PFBASESOURCE) $(IO_SOURCE)

VPATH = .:$(CSRCDIR):$(CSRCDIR)/posix:$(CSRCDIR)/stdio


CPPFLAGS = -I. -DPF_BIG_ENDIAN_DIC -DPF_SUPPORT_FP
CFLAGS = $(CCOPTS)
LDFLAGS = $(WIDTHOPT) -lm

COMPILE = $(CC) $(CFLAGS) $(CPPFLAGS)

# Cross compiler flags (for VBCC not gcc)
XCFLAGS = +tos -c99 -O3
#XCPPFLAGS = -DPF_SUPPORT_FP -DWIN32
XCPPFLAGS = -I. -DATARI -DPF_SUPPORT_FP
XLDFLAGS = +tos -lm -lm881

XCOMPILE = $(XCC) $(XCFLAGS) $(XCPPFLAGS)
XLINK = $(XCC) $(XLDFLAGS)

.SUFFIXES: .c .o .eo

PFOBJS     = $(PFSOURCE:.c=.o)
PFEMBOBJS  = $(PFSOURCE:.c=.eo)

.c.o: $(PFINCLUDES)
	$(COMPILE) -c -o $@ $<

.c.eo: $(PFINCLUDES) pfdicdat.h
	$(XCOMPILE) $(EMBCCOPTS) -c -o $@ $<

.PHONY: all clean test
.PHONY: help pffiles pfdicapp pfdicdat pforthapp

all: $(PFORTHAPP)

pffiles:
	@echo "INCLUDE FILES -----------------"
	@echo ${PFINCLUDES}
	@echo "'C' FILES ---------------------"
	@echo ${PFSOURCE}
	@echo "OBJECT FILES ------------------"
	@echo ${PFOBJS}
	@echo "EMBEDDED OBJECT FILES ------------------"
	@echo ${PFEMBOBJS}

# Build pforth by compiling 'C' source.
$(PFDICAPP): $(PFINCLUDES) $(PFOBJS)
	$(CC) -o $@ $(PFOBJS) $(LDADD) $(LDFLAGS)

# Build basic dictionary image by running newly built pforth and including "system.fth".
$(PFORTHDIC): $(PFDICAPP)
	wd=$$(pwd); (cd $(FTHDIR); $${wd}/$(PFDICAPP) -i system.fth)
	(cd $(FTHDIR); cat pforth.dic; rm -f pforth.dic) > $@

$(PFDICDAT): $(PFORTHDIC) $(PFDICAPP)
	echo 'include $(FTHDIR)/savedicd.fth SDAD'>load-dict-tmp.fth&& ./$(PFDICAPP) -d $(PFORTHDIC) load-dict-tmp.fth; rm -f load-dict-tmp.fth

$(PFORTHAPP): $(PFDICDAT) $(PFEMBOBJS)
	$(XLINK) -o $@ $(PFEMBOBJS) $(XLDADD)
	@echo ""
	@echo "Standalone pForth executable written to $(PFORTHAPP)"


# target aliases
pfdicapp: $(PFDICAPP)

pfdicdat: $(PFDICDAT)

pforthapp: $(PFORTHAPP)

help:
	@echo "Use 'make all' to build standalone pForth executable."
	@echo "PForth can be built in several stages using these targets:"
	@echo "   pfdicapp = executable pForth with minimal dictionary. All from 'C'."
	@echo "   pfdicdat = image of full dictionary build by compiling Forth code."
	@echo "   pforthapp = executable with embedded dictionary image. DEFAULT 'all' target."
	@echo ""
	@echo "   The file 'fth/pfdicdat.h' is generated by pForth. It contains a binary image of the Forth dictionary."
	@echo "   It allows pForth to work as a standalone image that does not need to load a dictionary file."

test: $(PFORTHAPP)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_corex.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_strings.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_locals.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_alloc.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_floats.fth)

clean:
	rm -f $(PFOBJS) $(PFEMBOBJS)
	rm -f $(PFORTHAPP)
	rm -f $(PFDICDAT) $(FTHDIR)/$(PFDICDAT)
	rm -f $(PFORTHDIC) $(FTHDIR)/$(PFORTHDIC)
	rm -f $(PFDICAPP)

=== platforms/mingw-crossbuild-linux/Makefile ===
# makefile for pForth
# Portable Forth written in 'C'
# by Phil Burk
# For more info visit http://www.softsynth.com/pforth/
#
# See "help" target below.

.POSIX:

# Options include: PF_SUPPORT_FP PF_NO_MALLOC PF_NO_INIT PF_DEBUG
# See "docs/pf_ref.htm" file for more info.

CC           = x86_64-w64-mingw32-gcc
WINE         = wineconsole
SRCDIR       = ../..
PFORTHDIR    = $(SRCDIR)
CSRCDIR      = $(PFORTHDIR)/csrc
FTHDIR       = $(PFORTHDIR)/fth

PFDICAPP     = pforth.exe
PFORTHDIC    = pforth.dic
PFDICDAT     = pfdicdat.h
PFORTHAPP    = pforth_standalone.exe

# This is needed to get pForth to build on Snow Leopard and other 64 bit platforms.
WIDTHOPT=

FULL_WARNINGS =  \
        --std=c89 \
        -fsigned-char \
        -fno-builtin \
        -fno-unroll-loops \
        -fpeephole \
        -fno-keep-inline-functions \
        -pedantic \
        -Wcast-qual \
        -Wall \
        -Wwrite-strings \
        -Winline  \
        -Wmissing-prototypes \
        -Wmissing-declarations

DEBUGOPTS = -g
CCOPTS = $(WIDTHOPT) -x c -O2 $(FULL_WARNINGS) $(EXTRA_CCOPTS) $(DEBUGOPTS)

#IO_SOURCE = pf_io_posix.c
#IO_SOURCE = pf_io_stdio.c
IO_SOURCE = pf_io_win32_console.c pf_fileio_stdio.c

EMBCCOPTS = -DPF_STATIC_DIC

#######################################
PFINCLUDES = pf_all.h pf_cglue.h pf_clib.h pf_core.h pf_float.h \
	pf_guts.h pf_host.h pf_inc1.h pf_io.h pf_mem.h pf_save.h \
	pf_text.h pf_types.h pf_win32.h pf_words.h pfcompfp.h \
	pfcompil.h pfdicdat_arm.h pfinnrfp.h pforth.h
PFBASESOURCE = pf_cglue.c pf_clib.c pf_core.c pf_inner.c \
	pf_io.c pf_io_none.c pf_main.c pf_mem.c pf_save.c \
	pf_text.c pf_words.c pfcompil.c pfcustom.c
PFSOURCE = $(PFBASESOURCE) $(IO_SOURCE)

VPATH = .:$(CSRCDIR):$(CSRCDIR)/posix:$(CSRCDIR)/stdio:$(CSRCDIR)/win32_console:$(CSRCDIR)/win32

XCFLAGS = $(CCOPTS)
#XCPPFLAGS = -DPF_SUPPORT_FP -DWIN32
XCPPFLAGS = -DWIN32
XLDFLAGS = $(WIDTHOPT)

CPPFLAGS = -I. $(XCPPFLAGS)
CFLAGS = $(XCFLAGS)
LDFLAGS = $(XLDFLAGS)

COMPILE = $(CC) $(CFLAGS) $(CPPFLAGS)
LINK = $(CC) $(LDFLAGS)

.SUFFIXES: .c .o .eo

PFOBJS     = $(PFSOURCE:.c=.o)
PFEMBOBJS  = $(PFSOURCE:.c=.eo)

.c.o: $(PFINCLUDES)
	$(COMPILE) -c -o $@ $<

.c.eo: $(PFINCLUDES) pfdicdat.h
	$(COMPILE) $(EMBCCOPTS) -c -o $@ $<

.PHONY: all clean test
.PHONY: help pffiles pfdicapp pfdicdat pforthapp

all: $(PFORTHAPP)

pffiles:
	@echo "INCLUDE FILES -----------------"
	@echo ${PFINCLUDES}
	@echo "'C' FILES ---------------------"
	@echo ${PFSOURCE}
	@echo "OBJECT FILES ------------------"
	@echo ${PFOBJS}
	@echo "EMBEDDED OBJECT FILES ------------------"
	@echo ${PFEMBOBJS}

# Build pforth by compiling 'C' source.
$(PFDICAPP): $(PFINCLUDES) $(PFOBJS)
	$(LINK) -o $@ $(PFOBJS) $(LDADD) -lm

# Build basic dictionary image by running newly built pforth and including "system.fth".
$(PFORTHDIC): $(PFDICAPP)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFDICAPP) -i system.fth)
	(cd $(FTHDIR); cat pforth.dic; rm -f pforth.dic) > $@

$(PFDICDAT): $(PFORTHDIC) $(PFDICAPP)
	echo 'include $(FTHDIR)/savedicd.fth SDAD BYE'>load-dict-tmp.fth&& $(WINE) ./$(PFDICAPP) -d $(PFORTHDIC) load-dict-tmp.fth; rm -f load-dict-tmp.fth

$(PFORTHAPP): $(PFDICDAT) $(PFEMBOBJS)
	$(LINK) -o $@ $(PFEMBOBJS) $(LDADD) -lm
	@echo ""
	@echo "Standalone pForth executable written to $(PFORTHAPP)"


# target aliases
pfdicapp: $(PFDICAPP)

pfdicdat: $(PFDICDAT)

pforthapp: $(PFORTHAPP)

help:
	@echo "Use 'make all' to build standalone pForth executable."
	@echo "PForth can be built in several stages using these targets:"
	@echo "   pfdicapp = executable pForth with minimal dictionary. All from 'C'."
	@echo "   pfdicdat = image of full dictionary build by compiling Forth code."
	@echo "   pforthapp = executable with embedded dictionary image. DEFAULT 'all' target."
	@echo ""
	@echo "   The file 'fth/pfdicdat.h' is generated by pForth. It contains a binary image of the Forth dictionary."
	@echo "   It allows pForth to work as a standalone image that does not need to load a dictionary file."

test: $(PFORTHAPP)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_corex.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_strings.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_locals.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_alloc.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_floats.fth)
	wd=$$(pwd); (cd $(FTHDIR); $(WINE) $${wd}/$(PFORTHAPP) -q t_file.fth)

clean:
	rm -f $(PFOBJS) $(PFEMBOBJS)
	rm -f $(PFORTHAPP)
	rm -f $(PFDICDAT) $(FTHDIR)/$(PFDICDAT)
	rm -f $(PFORTHDIC) $(FTHDIR)/$(PFORTHDIC)
	rm -f $(PFDICAPP)

=== platforms/unix/Makefile ===
# makefile for pForth
# Portable Forth written in 'C'
# by Phil Burk
# For more info visit http://www.softsynth.com/pforth/
#
# See "help" target below.

.POSIX:

# Options include: PF_SUPPORT_FP PF_NO_MALLOC PF_NO_INIT PF_DEBUG
# See "docs/pf_ref.htm" file for more info.

SRCDIR       = ../..
PFORTHDIR    = $(SRCDIR)
CSRCDIR      = $(PFORTHDIR)/csrc
FTHDIR       = $(PFORTHDIR)/fth
UNIXDIR      = platforms/unix

PFDICAPP     = pforth
PFORTHDIC    = pforth.dic
PFDICDAT     = pfdicdat.h
PFORTHAPP    = pforth_standalone

# Set this parameter to -m32 if you want to compile a 32-bit binary.
WIDTHOPT=

FULL_WARNINGS =  \
        --std=c89 \
        -fsigned-char \
        -fno-builtin \
        -fno-unroll-loops \
        -pedantic \
        -Wcast-qual \
        -Wall \
        -Wwrite-strings \
        -Winline  \
        -Wmissing-prototypes \
        -Wmissing-declarations

DEBUGOPTS = -g
CCOPTS = $(WIDTHOPT) -x c -O2 $(FULL_WARNINGS) $(EXTRA_CCOPTS) $(DEBUGOPTS)

IO_SOURCE = pf_io_posix.c pf_fileio_stdio.c
#IO_SOURCE = pf_io_stdio.c

EMBCCOPTS = -DPF_STATIC_DIC #-DPF_NO_FILEIO

#######################################
PFINCLUDES = pf_all.h pf_cglue.h pf_clib.h pf_core.h pf_float.h \
	pf_guts.h pf_host.h pf_inc1.h pf_io.h pf_mem.h pf_save.h \
	pf_text.h pf_types.h pf_win32.h pf_words.h pfcompfp.h \
	pfcompil.h pfinnrfp.h pforth.h
PFBASESOURCE = pf_cglue.c pf_clib.c pf_core.c pf_inner.c \
	pf_io.c pf_io_none.c pf_main.c pf_mem.c pf_save.c \
	pf_text.c pf_words.c pfcompil.c pfcustom.c
PFSOURCE = $(PFBASESOURCE) $(IO_SOURCE)

VPATH = .:$(CSRCDIR):$(CSRCDIR)/posix:$(CSRCDIR)/stdio:$(CSRCDIR)/win32_console:$(CSRCDIR)/win32

XCFLAGS = $(CCOPTS)
XCPPFLAGS = -DPF_SUPPORT_FP -D_DEFAULT_SOURCE -D_GNU_SOURCE
XLDFLAGS = $(WIDTHOPT)

CPPFLAGS = -I. $(XCPPFLAGS)
CFLAGS = $(XCFLAGS)
LDFLAGS = $(XLDFLAGS)

COMPILE = $(CC) $(CFLAGS) $(CPPFLAGS)
LINK = $(CC) $(LDFLAGS)

.SUFFIXES: .c .o .eo

PFOBJS     = $(PFSOURCE:.c=.o)
PFEMBOBJS  = $(PFSOURCE:.c=.eo)

%.o: %.c $(PFINCLUDES)
	$(COMPILE) -c -o $@ $<

%.eo: %.c $(PFINCLUDES) pfdicdat.h
	$(COMPILE) $(EMBCCOPTS) -c -o $@ $<

.PHONY: all clean test
.PHONY: help pffiles pfdicapp pfdicdat pforthapp

all: $(PFORTHAPP)

pffiles:
	@echo "INCLUDE FILES -----------------"
	@echo ${PFINCLUDES}
	@echo "'C' FILES ---------------------"
	@echo ${PFSOURCE}
	@echo "OBJECT FILES ------------------"
	@echo ${PFOBJS}
	@echo "EMBEDDED OBJECT FILES ------------------"
	@echo ${PFEMBOBJS}

# Build pforth by compiling 'C' source.
$(PFDICAPP): $(PFINCLUDES) $(PFOBJS)
	$(LINK) -o $@ $(PFOBJS) $(LDADD) -lm

# Build basic dictionary image by running newly built pforth and including "system.fth".
$(PFORTHDIC): $(PFDICAPP)
	wd=$$(pwd); (cd $(FTHDIR); "$${wd}/$(PFDICAPP)" -i system.fth)
	(cd $(FTHDIR); cat pforth.dic; rm -f pforth.dic) > $@

$(PFDICDAT): $(PFORTHDIC) $(PFDICAPP)
	@test -f $(CSRCDIR)/$(PFDICDAT) && echo WARNING old $(CSRCDIR)/$(PFDICDAT) would interfere || true
	# Remove stray csrc/pfdicdat.h because it may accidentally get included.
	rm -f $(CSRCDIR)/$(PFDICDAT)
	echo 'include $(FTHDIR)/savedicd.fth SDAD BYE' | ./$(PFDICAPP) -d $(PFORTHDIC)

$(PFORTHAPP): $(PFDICDAT) $(PFEMBOBJS)
	$(LINK) -o $@ $(PFEMBOBJS) $(LDADD) -lm
	@echo ""
	@echo "Standalone pForth executable written to $(PFORTHAPP)"

# target aliases
pfdicapp: $(PFDICAPP)

pforthdic: $(PFORTHDIC)

pfdicdat: $(PFDICDAT)

pforthapp: $(PFORTHAPP)

help:
	@echo "Use 'make all' to build standalone pForth executable."
	@echo "PForth can be built in several stages using these targets:"
	@echo "   pfdicapp = executable pForth with minimal dictionary. All from 'C'."
	@echo "   pforthdic = executable pforth plus pforth.dic file"
	@echo "   pfdicdat = header image of full dictionary build by compiling Forth code."
	@echo "   pforthapp = executable with embedded dictionary image. DEFAULT 'all' target."
	@echo ""
	@echo "   The file 'fth/pfdicdat.h' is generated by pForth. It contains a binary image of the Forth dictionary."
	@echo "   It allows pForth to work as a standalone image that does not need to load a dictionary file."

test: $(PFORTHAPP)
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_corex.fth
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_strings.fth
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_locals.fth
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_alloc.fth
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_floats.fth
	cd $(FTHDIR) && ../$(UNIXDIR)/$(PFORTHAPP) -q t_file.fth
	@echo "PForth Tests PASSED"

clean:
	rm -f $(PFOBJS) $(PFEMBOBJS)
	rm -f $(PFORTHAPP)
	rm -f $(PFDICDAT) $(FTHDIR)/$(PFDICDAT) $(CSRCDIR)/$(PFDICDAT)
	rm -f $(PFORTHDIC) $(FTHDIR)/$(PFORTHDIC)
	rm -f $(PFDICAPP)

=== debian/changelog ===
pforth (1:2.0.1-1) unstable; urgency=low

  * new upsgream version, fixes test suite on 32 bit architectures

 -- Bdale Garbee <bdale@gag.com>  Mon, 09 Jan 2023 16:55:24 -0700

pforth (1:2.0.0-1) unstable; urgency=low

  * add version epoch due to upstream change in version number format
  * new upstream version, closes: #791945
  * enable build on arm64, closes: #791946
  * switch to 3.0 (quilt) source format, closes: #1007613
  * upgrade to modern debhelper, control file contents

 -- Bdale Garbee <bdale@gag.com>  Mon, 02 Jan 2023 14:13:49 -0700

pforth (21-12) unstable; urgency=low

  * add Vcs entries to the control file
  * add powerpcspe to architecture list, closes: #731651
  * add armhf to architecture list by request of Luca Masini

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Jan 2014 14:01:24 -0700

pforth (21-11) unstable; urgency=low

  * add armeb and armel to architecture list, closes: #408789

 -- Bdale Garbee <bdale@gag.com>  Sun, 18 Feb 2007 15:11:53 -0800

pforth (21-10) unstable; urgency=low

  * add kfreebsd-i386 to the list of buildable architectures, closes: #314812
  * clean up debian/copyright file, closes: #302978
  * move to newer debhelper compat level, fix assorted lintian warnings

 -- Bdale Garbee <bdale@gag.com>  Sun, 17 Jul 2005 13:55:20 +0300

pforth (21-9) unstable; urgency=low

  * add hppa to list of supported architectures, closes: #131276
  * lose the '-x c++' from the Makefile, since it appears bogus (pForth is 
    ANSI C, not C++) and hppa fails to link if it is using gcc for C++.  
    Thanks to James Troup for figuring this out.
  * clean up a few cosmetic uglies and make lintian happy

 -- Bdale Garbee <bdale@gag.com>  Mon, 28 Jan 2002 09:20:13 -0700

pforth (21-8) unstable; urgency=low

  * add s390 to list of supported architectures, closes: #127760

 -- Bdale Garbee <bdale@gag.com>  Fri,  4 Jan 2002 10:08:52 -0700

pforth (21-7) unstable; urgency=low

  * clean up lintian reports

 -- Bdale Garbee <bdale@gag.com>  Tue,  1 Jan 2002 10:30:48 -0700

pforth (21-6) unstable; urgency=low

  * add hurd-i386 to supported architectures in control, closes: #55122

 -- Bdale Garbee <bdale@gag.com>  Fri, 14 Jan 2000 23:51:08 -0700

pforth (21-5) unstable; urgency=low

  * prefix invocation of new pforth binary in makefile with './' so that '.'
    doesn't need to be in builder's path.  Closes: #53627

 -- Bdale Garbee <bdale@gag.com>  Tue, 28 Dec 1999 10:42:18 -0700

pforth (21-4) unstable; urgency=low

  * recompile so libstdc++ dependency is current for potato, closes: #53452
  * building on alpha was "fixed" in -3 by using an explicit arch list, and
    there's no sign of an alpha port.  Closes: #39298

 -- Bdale Garbee <bdale@gag.com>  Mon, 27 Dec 1999 11:16:32 -0700

pforth (21-3) unstable; urgency=low

  * switch to an explicit architecture specification in the control file,
    since this is a 32-bit implementation, doesn't work on alpha, and is
    unlikely to work out of the box on other new processors that come along.

 -- Bdale Garbee <bdale@gag.com>  Sat, 19 Jun 1999 10:45:10 -0600

pforth (21-2) unstable; urgency=low

  * oops, fix a typo in the man page
  * include the rest of the documentation provided with the upstream sources

 -- Bdale Garbee <bdale@gag.com>  Sun, 27 Dec 1998 12:22:42 -0700

pforth (21-1) unstable; urgency=low

  * move to newer upstream source pointed out by author
  * implement central default location for pforth.dic file, providing diffs 
    to upstream author

 -- Bdale Garbee <bdale@gag.com>  Sun, 27 Dec 1998 09:16:11 -0700

pforth (19-1) unstable; urgency=low

  * Initial packaging of pforth, never uploaded.

 -- Bdale Garbee <bdale@gag.com>  Thu, 24 Dec 1998 01:55:27 -0700

=== debian/control ===
Source: pforth
Section: interpreters
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 13)
Standards-Version: 4.5.1
Homepage:  https://github.com/philburk/pforth
Vcs-Browser: https://salsa.debian.org/debian/pforth
Vcs-Git: https://salsa.debian.org/debian/pforth.git

Package: pforth
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Portable ANS-like Forth written in ANSI 'C'
 PForth is a public domain, portable Forth interpreter.
 .
 PForth is written in 'C' and can be easily ported to new 32 and 64-bit 
 platforms. It only needs character input and output functions to operate 
 and, therefore, does not require an operating system. This makes it handy 
 for bringing up and testing embedded systems.
 .
 PForth also works on desktops including Windows, Mac and Linux and supports 
 command line history. This lets you develop hardware tests on a desktop 
 before trying them on your embedded system. But pForth is not a rich and 
 friendly desktop programming environment. There are no GUI tools for 
 developing desktop applications. PForth is lean and mean and optimized for 
 portability.
 .
 PForth has a tool for compiling code on a desktop, then exporting the 
 dictionary in big or little endian format as 'C' source code. This lets you 
 compile tests for an embedded system that does not have file I/O.
 .
 PForth is based on ANSI-Forth but is not 100% compatible. 
 .
 Dcoumentation for PForth is available at http://www.softsynth.com/pforth/

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	true

override_dh_auto_build:
	(cd platforms/unix ; make clean test)
	mv platforms/unix/pforth_standalone platforms/unix/pforth

override_dh_auto_clean:
	(cd platforms/unix ; make clean)
	rm -f platforms/unix/pforth

## pforth 21

=== Makefile ===
# @(#) rlsMakefile 97/12/10 1.1
# makefile for pForth
# Portable Forth written in 'C'
# Phil Burk

.SUFFIXES: .c .o

# Options include: PF_SUPPORT_FP PF_NO_MALLOC PF_NO_INIT PF_DEBUG
# See "docs/pf_ref.htm" file for more info.

SOURCEDIR = csrc
OBJECTDIR = objects
EMBOBJECTDIR = embobjects

FULL_WARNINGS =  -O2 \
        -fsigned-char \
        -fno-builtin \
        -fno-unroll-loops \
        -fpeephole \
        -fno-keep-inline-functions \
        -x c++ \
        -Wcast-qual \
        -Wall \
        -Wwrite-strings \
        -Winline  \
        -Wmissing-prototypes \
        -Wmissing-declarations
        
CCOPTS = -DPF_SUPPORT_FP $(FULL_WARNINGS)
COMPILER = gcc

EMBCCOPTS = -DPF_NO_INIT -DPF_NO_MALLOC -DPF_NO_FILEIO \
    -DPF_NO_CLIB -DPF_STATIC_DIC

#######################################
# Build file lists from wildcards.
PFITEMP    = ${wildcard ${SOURCEDIR}/*.h}
PFINCLUDES = ${PFITEMP:${SOURCEDIR}/pfdicdat.h=}
PFSOURCE   = ${wildcard ${SOURCEDIR}/*.c}
PFTEMP     = ${PFSOURCE:%.c=%.o}
PFOBJS     = ${PFTEMP:${SOURCEDIR}/%=${OBJECTDIR}/%}
PFEMBOBJS  = ${PFTEMP:${SOURCEDIR}/%=${EMBOBJECTDIR}/%}

COMPILE = $(COMPILER) $(CCOPTS) $(CDEFS)

${OBJECTDIR}/%.o:  $(PFINCLUDES)  ${SOURCEDIR}/%.c
	$(COMPILE) -O -o ${OBJECTDIR}/$*.o -c ${SOURCEDIR}/$*.c
	
${EMBOBJECTDIR}/%.o:  $(PFINCLUDES) ${SOURCEDIR}/%.c ${SOURCEDIR}/pfdicdat.h 
	$(COMPILE) -O -o ${EMBOBJECTDIR}/$*.o -c ${SOURCEDIR}/$*.c $(EMBCCOPTS)

all: pforth pforth.dic

pffiles:
	echo "ITEMP FILES -----------------"
	echo ${PFITEMP}
	echo "INCLUDE FILES -----------------"
	echo ${PFINCLUDES}
	echo "'C' FILES ---------------------"
	echo ${PFSOURCE}
	echo "OBJECT FILES ------------------"
	echo ${PFOBJS}
	echo "EMBEDDED OBJECT FILES ------------------"
	echo ${PFEMBOBJS}
	
# build pforth by compiling 'C' source
pforth: $(PFINCLUDES) $(PFOBJS)
	$(COMPILER) $(PFOBJS) -lm -o pforth

# build basic dictionary by running newly built pforth and including system.fth
pforth.dic: pforth
	pforth -i system.fth

${SOURCEDIR}/pfdicdat.h: pforth pforth.dic
	@(echo 'INCLUDE utils/savedicd.fth'; \
          echo 'SDAD';         \
          echo 'bye')                                 | \
	pforth -dpforth.dic
	cp pfdicdat.h ${SOURCEDIR}


pfemb: $(PFINCLUDES) $(PFEMBOBJS)
	$(COMPILER) $(PFEMBOBJS) -lm -o pfemb
	
clean:
	rm -f $(PFOBJS) $(PFEMBOBJS) pforth *.dic core ${SOURCEDIR}/pfdicdat.h pfemb
